module Exam.Exercise2.Substitution where

open import Relation.Nullary using (Dec; yes; no; ¬_)
open import Data.String      using (_≟_)

open import Exam.Exercise2.Syntax

infix 9 _[_:=_]

_[_:=_] : Term → Id → Term → Term
(` y)     [ x := L ] with x ≟ y
... | yes x≡y = L
... | no  x≢y = ` y
(ƛ y ⇒ M) [ x := L ] with x ≟ y
... | yes x≡y = ƛ y ⇒ M
... | no  x≢y = ƛ y ⇒ M [ x := L ] -- exploiting that L is closed!
(M · N)   [ x := L ] = (M [ x := L ]) · (N [ x := L ])
`zero     [ x := L ] = `zero
(`suc M)  [ x := L ] = `suc (M [ x := L ])
case M [zero⇒ M₁ |suc y ⇒ M₂ ] [ x := L ] with x ≟ y
... | yes x≡y = case (M [ x := L ]) [zero⇒ (M₁ [ x := L ]) |suc y ⇒ M₂ ]
... | no  x≢y = case (M [ x := L ]) [zero⇒ (M₁ [ x := L ]) |suc y ⇒ M₂ [ x := L ] ]
(μ y ⇒ M) [ x := L ] with x ≟ y
... | yes x≡y = μ y ⇒ M
... | no  x≢y = μ y ⇒ M [ x := L ]

-- The following cases are new:

(`new M)  [ x := L ] = `new (M [ x := L ])
(M ≔ N)   [ x := L ] = (M [ x := L ]) ≔ (N [ x := L ])
(! M)     [ x := L ] = ! (M [ x := L ])
(`loc ℓ)  [ x := L ] = `loc ℓ
`tt       [ x := L ] = `tt

-- Note that none of the cases is very interesting: the new terms do neither
-- define nor use variables, so substitution simply propagates through to
-- subterms, leaving everything else unchanged.
